# 背景轮换 / bg-change

> a jQuery plugin

---

## 安装插件

- 加载页面使用的 `js` 插件

    `bower install`

---

## 作用说明

`jQuery` 插件，用于背景图片的更换。

## 方法说明

- `.bgChange(imageArray,options)`;

### 参数说明

- `imageArray`：需要更换的图片列表
- `options`：设置参数（更改默认的行数和列数）默认为：`{"row":7,"col":9,"scss":true}`

### options参数说明

- `row` ：需要生成的行数
- `col` ：需要生成的列数
- `scss` ：是否引入 `scss` 文件，若不用 `scss` 文件则需要引入 `changContain.css` 。提供 `.chang-contain` 类，默认为7行9列。


**注：** 使用该方法后，不再支持链式调用。方法返回一个对象，对象内容如下：

```
{
    change: Function,
    method: [],
    changeImages: Function
}
```

背景图需要改变时，只需要调用返回对象中的 `.change` 方法即可，所以建议将返回值单独保存为一个变量。

```
var a = $('eleName').bgChange(imageArray,row,col);
a.change();
```

`method` 中存放动画的运动形式，`changeImages` 用于更换背景切换的图片（将图片地址数组传入即可）。

默认调用 `change` 方法为随机调用 `method` 列表中的一个，和使用默认的动画 `start-change` ，也可主动为 `change` 方法设置参数，规定运动形式和动画效果。

`start-change` 图片切换时应用的样式，默认为缩小。使用 `transition` 过渡动画，所以只需规定动画最终效果即可。

```
// 使用默认
a.change();

// 使用规定的运动和动画效果
a.change(a.method[2], className //自定义的类名);
```

**注1：** `method` 内置了15种运动形式，可参照例子自己编写。`className` 为动画效果，可自己编写，将编写好的运动形式和动画效果传入即可。

**注2：** 如若需要更改行数和列数，不仅仅需要传入 `row` 和 `col` 参数，需要同时要引用一个 `mixin` 。如果项目不是用 `scss` 编写，可简单的引入 `changeContain.css` ，默认提供 `.chang-contain` 类7行9列的排列方式。

**注3：** 为jQuery扩展了一个 `preLoad` 方法，用于预加载图片，解决图片因为未加载好而显示不全的问题。

具体的编写方式，可查看项目中的例子。例子简要的介绍了 `4` 种常用的用于初始化背景的方式。

有任何问题，可以联系我。[wwsxuan@163.com](mailto:wwsxuan@163.com)
