/* load gulp */

var gulp = require('gulp');

/* load plugins for gulpStream*/

var autoprefixer = require('autoprefixer'),
    del = require('del'),
    filter = require('gulp-filter'),
    sass = require('gulp-sass'),
    cleanCss = require('gulp-clean-css'),
    postcss = require('gulp-postcss'),
    rename = require('gulp-rename'),
    uglify = require('gulp-uglify');

gulp.task('clean', () => {
    return del(['./bgChange.min.js', './changContain.css']);
});

gulp.task('styles', () => {
    return gulp.src('./changContain.scss')
        .pipe(sass())
        .pipe(postcss([
            autoprefixer({
                browsers: ['last 3 version']
            })
        ]))
        .pipe(cleanCss())
        .pipe(gulp.dest('./'));
});

gulp.task('javascript', () => {
    return gulp.src('./bgChange.js')
        .pipe(uglify())
        .pipe(rename(function(path) {
            path.basename += ".min";
        }))
        .pipe(gulp.dest('./'));
});

gulp.task('default', gulp.parallel('clean', 'styles', 'javascript'));
